Subject: Re: safe.directory wildcards

From: Patrick Steinhardt <[email-masked]>
Date: Fri, 31 May 2024 10:18:28 +0200

On Wed, May 29, 2024 at 09:02:16AM -0700, Junio C Hamano wrote:
> Stefan Metzmacher <[email-masked]> writes:
> 
> > given the recent importance of safe.directory, it would be great to
> > have something like '/data/git/*' to be supported, not just a single '*'
> > for a server that serves a lot of public git repositories owned by different owners.
> 
> Interesting.
> 
> The original commit that introduced the '*' opt-out, 0f85c4a3
> (setup: opt-out of check with safe.directory=*, 2022-04-13), was
> done to specifically help those who have a large list of shared
> repositories.  We could have moved all the way to allow globs back
> then, and the possibility certainly was brought up.
> 
>   https://lore.kernel.org/git/[email-masked]/
> 
> But the loosening was done in a context of "brown paper bag fix"
> so it is very much understandable that we did the simplest and most
> obvious thing to avoid making silly mistakes in a haste.
> 
> I am reluctant to use wildmatch() but I would expect that in
> practice "leading path matches" (in other words, "everything under
> this directory is OK") is sufficient, perhaps?

Is there any particular reason why you don't want to use wildmatch?
I'd think it to be a natural fit here, and it would provide a superset
of functionality provided by leading paths, only.

Patrick